# Релизы Timeweb Cloud CLI

В этом файле описаны все значимые изменения в Timeweb Cloud CLI. В выпусках мы придерживается правил [семантического версионирования](https://semver.org/lang/ru/).

# Версия 1.3.1 (2023.04.13)

Изменено:

- В команде `twc s3 mb` опция `--preset-id` теперь необязательная. Будет выбран минимальный пресет.

Исправлено:

- Исправлена ошибка при попытке создать дополнительный профиль через `twc config`.

# Версия 1.3.0 (2023.04.13)

Добавлено:

- Добавлена команда `twc storage` (алиас `twc s3`) для управления бакетами в объектном хранилище Timeweb Cloud. Доступны базовые операции с бакетами. Также реализованы субкоманды для работы с доменами и пользователями хранилища. Обратите внимание, что в twc не планируется добавлять реализацию S3-клиента, пользуйтесь любым совместимым клиентом, например, [s3cmd](https://s3tools.org/s3cmd) или [rclone](https://rclone.org/), команда `twc s3 genconfig` позволит сгенерировать конфигурационный файл для этих утилит (см. [документацию](docs/ru/README.md#получение-конфигурации-для-s3-клиентов)).
- Добавлены субкоманды для `twc config`. Теперь можно: сделать дамп настроек CLI (`twc config dump`), изменять настройки без ручного редактирования файла (`twc config set`), получить путь до файла (`twc config file`), открыть файл в редакторе по умолчанию (`twc config edit`).

Изменено:

- Изменены тексты ошибок при работе с конфигурационным файлом, теперь они более наглядные и явно указывают на проблему.
- Изменено поведение команды `twc config`. Теперь если уже иммется конфигурационный файл команда предложит добавить новый профиль или отредактировать существующий.

# Версия 1.2.0 (2023.04.03)

Добавлено:

- Добавлена команда `twc database` (алиас `twc db`). Теперь можно:
    - создавать и удалять управляемые базы данных;
    - изменять параметры базы данных;
    - работать с бэкапами баз данных.
- Реализована возможность работы с токенами, которые требуют подтверждения удаления сервисов через проверочные коды.
- Добавлены алиасы для основных команд, набирать команды стало ещё быстрее. Например, `twc server list` можно сократить до `twc s ls`. Смотрите список алиасов во встроенной справке `--help`.
- Добавлены команды `twc server dash` и `twc server vnc`. С их помощью можно быстро перейти в дашборд и веб-консоль сервера соответсвенно. Ссылки откроются в браузере по умолчанию.

Изменено:

- Поменялся вывод команд `twc server list-presets` и `twc server backup list`, скрыты малоинформативные колонки.
- Мелкие улучшения в коде.


# Версия 1.1.0 (2023.03.24)

Добавлено:

- Добавлена команда `twc image` для управления образами дисков. Можно создавать образы из существующих дисков, загрузить свой образ по ссылке, удалять образы и выполнять другие базовые операции.
- Добавлена возможность использовать UUID пользовательского образа при создании нового сервера (`twc server create`) и при переустановке сервера (`twc server reinstall`).
- Добавлена команда `twc project` для управления проектами и ресурсами в них: создание, удаление, редактирование проектов, перемещение ресурсов между проектами.
- В команду `twc server create` добавлена опция `--project-id`, которая позволяет переместить только что созданный сервер в указанный проект. Задать проект можно также через переменную окружения `TWC_PROJECT` и конфигурационный файл.
- В команду `twc server reinstall` добавлена опция `--add-ssh-key`. Теперь опционально после переустановки на сервер будут добавлены SSH-ключи, которые были на нём ранее.
- Добавлена команда `twc server disk list-all`. Она покажет список всех дисков со всех серверов.
- Опция `--filter` в командах где она есть теперь поддерживает поиск по полям, содержащим значения в мегабайтах и гагибайтах.

Изменено:

- Команда `twc server reinstall` теперь не требует `--image` как обязательный аргумент. Если опция не задана будет выбрана ОС, которая уже установлена на сервере.
- В команде `twc server clone` теперь используется новый метод клонирования сервера. В ответ команда вернёт информацию о клоне сервера.
- В командах `twc server list` и `twc server logs` увеличен стандартный `--limit` до 500.
- В локации `pl-1` (Польша, Гданьск) теперь разрешено добавлять IPv6-адреса.
- В выводе `twc server list-presets` RAM и объём системного диска в табличном виде теперь отображаются в гигабайтах.

Исправлено:

- В выводе команды `twc server list-os-images` теперь правильно отображаем поле `REQUIREMENTS`.
- Исправлена ошибка из-за которой опция `--filter` не фильтровала по ключам, содержащим знак подчёркивания.

# Версия 1.0.0 (2023.02.27)

Первый релиз.
